#ifndef _DISTANCE_H
#define _DISTANCE_H

/**
 * getDistance gets the distance from the distance sensor at the given port
 * The unit of the calculated distance is in inches
 *
 * @requires none
 * @effects gets the distance from the detecting equpment and another object
 * @modifies none
 */
double getDistance(void);

/**
 * isClose is the function that checks if the distance from the distance sensor and its obstacles
 * The limit is as defined in define.h or umain().
 *
 * Returns 1 iff the distance from the Sharp Distance Sensor to the object is above the
 * defined threshold
 * Returns 0 otherwise
 *
 * @requires none
 * @effects Return
 */
uint8_t isClose(void);
#endif
