#ifndef _LED_H_
#define _LED_H_

/**
 * cali<xxx>Led calibrates the threshold of every led in <xxx> group
 * 
 * @requires none
 * @effect modify threshold_led_<yyy>
 * @modifies threshold_led_<yyy> where <yyy> be led names
 */
void caliUnderLed(void);
void caliLeftLed(void);
void caliRightLed(void);

/**
 * portToLed takes port number as input and returns led attached to that port
 * 
 * @requires valid ledPort
 * @effect return led number according to input port
 * @modifies none
 */
uint8_t portToLed(uint8_t ledPort);

/**
 * isBlack check color of the surface in front of the led
 * 
 * @requires valid ledPort
 * @effect return 1 if the surface is black, return 0 if the surface is white
 * @modifies none
 */
uint8_t isBlack(uint8_t ledPort);




#endif
